/*****************************************************
CVAVR V2.05
Chip type               : ATtiny43U
AVR Core Clock frequency: 8 MHz
*****************************************************/
#include <tiny43u.h>

#define A   PORTB.7
#define B   PORTB.6
#define C   PORTB.5
#define D   PORTB.4
#define E   PORTB.3
#define F   PORTB.2
#define G   PORTB.1
#define DP	PORTB.0
#define N0	PORTA.0
#define N1	PORTA.1
#define N2	PORTA.2
#define N3	PORTA.3

#define key0 PINA.5
#define key1 PINA.4

enum btn_states {prs, rls, hold} btn0=rls,btn1=rls;
unsigned char tkey[2]={0,0};
unsigned char EncState;
unsigned char EncData;

unsigned char display_buffer[4]={1,2,3,4}, dppos=0;
unsigned char tim[4];

bit a1,a0;

void gpio_cfg()
{
DDRA = 0x0f; PORTA = 0xf0;
DDRB = 0xff; PORTB = 0;
}
void t0_cfg()
{
TCCR0B=0x02;
TIMSK0=0x01;
}


void convert_data (unsigned int d)
{
unsigned char k;
  for (k=0;k<4;k++)
  {
   display_buffer[k]=d%10;
   d/=10;
  }
}
void display_data ()
{
  static unsigned char pc;

  (pc)?(pc--):(pc = 3);
  N0=N1=N2=N3=0; DP=1;

  switch (display_buffer[pc])
 {
  case 0: A=0; B=0; C=0; D=0; E=0; F=0; G=1; break;
  case 1: A=1; B=0; C=0; D=1; E=1; F=1; G=1; break;
  case 2: A=0; B=0; C=1; D=0; E=0; F=1; G=0; break;
  case 3: A=0; B=0; C=0; D=0; E=1; F=1; G=0; break;
  case 4: A=1; B=0; C=0; D=1; E=1; F=0; G=0; break;
  case 5: A=0; B=1; C=0; D=0; E=1; F=0; G=0; break;
  case 6: A=0; B=1; C=0; D=0; E=0; F=0; G=0; break;
  case 7: A=0; B=0; C=0; D=1; E=1; F=1; G=1; break;
  case 8: A=0; B=0; C=0; D=0; E=0; F=0; G=0; break;
  case 9: A=0; B=0; C=0; D=0; E=1; F=0; G=0; break;
  case ' ': A=1; B=1; C=1; D=1; E=1; F=1; G=1; break;
  case 'u': A=1; B=1; C=0; D=0; E=0; F=1; G=1; break;
  case 'c': A=1; B=1; C=1; D=0; E=0; F=1; G=0; break;
  case 'b': A=1; B=1; C=0; D=0; E=0; F=0; G=0; break;
  case 't': A=1; B=1; C=1; D=0; E=0; F=0; G=0; break;
  case 'l': A=1; B=1; C=1; D=0; E=0; F=1; G=1; break;
  case 'o': A=1; B=1; C=0; D=0; E=0; F=1; G=0; break;
  case 'A': A=0; B=0; C=0; D=1; E=0; F=0; G=0; break;
  case 'H': A=1; B=0; C=0; D=1; E=0; F=0; G=0; break;
  case 'C': A=0; B=1; C=1; D=0; E=0; F=0; G=1; break;
  case 'P': A=0; B=0; C=1; D=1; E=0; F=0; G=0; break;
  case 'E': A=0; B=1; C=1; D=0; E=0; F=0; G=0; break;
  case 'U': A=1; B=0; C=0; D=0; E=0; F=0; G=1; break;
  case 'F': A=0; B=1; C=1; D=1; E=0; F=0; G=0; break;
  case 'L': A=1; B=1; C=1; D=0; E=0; F=0; G=1; break;
  case 'r': A=1; B=1; C=1; D=1; E=0; F=1; G=0; break;
  case '_': A=1; B=1; C=1; D=0; E=1; F=1; G=1; break;
  case 'd': A=1; B=0; C=0; D=0; E=0; F=1; G=0; break;
  case 'n': A=1; B=1; C=0; D=1; E=0; F=1; G=0; break;
  default:  A=1; B=1; C=1; D=1; E=1; F=1; G=0; break; //-
 }

   switch (pc)
 {
  case 0: N0=1; if(dppos == 0) {DP=0;} break;
  case 1: N1=1; if(dppos == 1) {DP=0;} break;
  case 2: N2=1; if(dppos == 2) {DP=0;} break;
  case 3: if(display_buffer[3]){N3=1;} if(dppos == 3) {DP=0;} break;
  default: DP=1; break;
 }
 }
void scan_keys ()
{
#define lp  4
#define lh  20
#define lr  4

static unsigned char count[4];

if ((!key0)&&(!tkey[0])) {count[0]++;tkey[0]=lr;}
  else if((key0)&&(!tkey[0])) {count[0]=count[1]=0;btn0=rls;}
if ((count[0]>lp)&&(btn0!=hold)) {btn0=prs; count[0]=0; count[1]++;}
//if (count[1]>lh) {btn0=hold; count[1]=0;}

if ((!key1)&&(!tkey[1])) {count[2]++;tkey[1]=lr;}
  else if((key1)&&(!tkey[1])) {count[3]=count[2]=0;btn1=rls;}
if ((count[2]>lp)&&(btn1!=hold)) {btn1=prs; count[2]=0; count[3]++;}
//if (count[3]>lh) {btn1=hold; count[3]=0;}
}
void EncoderScan()
{
unsigned char New;

if(btn0==rls) a0=1; else a0=0;
if(btn1==rls) a1=1; else a1=0;
 
New = (a1<<1)+a0;
 
switch(EncState)
{
case 2:
{
if(New == 3) EncData++;
if(New == 0) EncData--; 
break;
}
 
case 0:
{
if(New == 2) EncData++;
if(New == 1) EncData--; 
break;
}
case 1:
{
if(New == 0) EncData++;
if(New == 3) EncData--; 
break;
}
case 3:
{
if(New == 1) EncData++;
if(New == 2) EncData--; 
break;
}
}
 
EncState = New;
}

interrupt [TIM0_OVF] void t0_ovf()
{
unsigned char i;

for(i=0;i<4;i++){if(tim[i])tim[i]--;}
for(i=0;i<2;i++){if(tkey[i])tkey[i]--;}
}

void main(void)
{
gpio_cfg();
t0_cfg();

dppos = 5;

#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

#asm("sei")

while (1)
      {

        convert_data(EncData); 
        display_data ();
        scan_keys (); 
        EncoderScan(); 

        
         
         


      }
}
